//
// 拖曳resize表格
//
var TableResize = {
	init: function() {
		$(document).delegate('td', 'mousemove', $.proxy(this.placeDraggerGuide, this));
		$(document).delegate('.table-row-resize-dragger', 'mousedown', $.proxy(this.startDragRowGuide, this));
		$(document).delegate('.table-column-resize-dragger', 'mousedown', $.proxy(this.startDragColumnGuide, this));
		$(document).bind('mouseup', $.proxy(this.clearWhenMouseUp, this));
	},

	uninit: function() {
		$(document).undelegate('td', 'mousemove', this.placeDraggerGuide);
		$(document).undelegate('.table-row-resize-dragger', 'mousedown', this.startDragRowGuide);
		$(document).undelegate('.table-column-resize-dragger', 'mousedown', this.startDragColumnGuide);
		$(document).unbind('mouseup', this.clearWhenMouseUp);
	},

	placeDraggerGuide: function(ev) {
		var td = $(ev.target).closest('td');
		var table = td.parents('.table-container');

		var draggerTop = td.offset().top - table.offset().top;
		if (draggerTop > 5) {
			// 当鼠标更靠近td的上边时，dragger放到上边，反之。
			if ((ev.pageY - td.offset().top) > (td.offset().top + td.outerHeight() - ev.pageY)) {
				draggerTop = td.offset().top + td.outerHeight() - table.offset().top;
			}
			table.find(".table-row-resize-dragger").css("top", draggerTop - 2 + "px").css("left", "0");	
		}

		var draggerLeft = td.offset().left - table.offset().left;
		if (draggerLeft > 5) {
			// 当鼠标更靠近td的左边时，dragger放到上边，反之。
			if ((ev.pageX - td.offset().left) > (td.offset().left + td.outerWidth() - ev.pageX)) {
				draggerLeft = td.offset().left + td.outerWidth() - table.offset().left;	
			}
			table.find(".table-column-resize-dragger").css("left", draggerLeft - 2 + "px").css("top", 0);	
		}
	},

	draggingWhat: '',
	dragStartTd: null,
	clearWhenMouseUp: function(ev) {
		if (this.draggingWhat == 'RowGuide') {
			this.endDragRowGuide(ev);
		} else if (this.draggingWhat == 'ColumnGuide') {
			this.endDragColumnGuide(ev);
		}
		this.draggingWhat = '';
	},

	table: null,

	disableSelection: function(ev) {
		ev.preventDefault();
		return false;
	},

	dragColumnStartY: 0,
	startDragRowGuide: function(ev) {
		var target = $(ev.target);
		this.table = target.closest('.table-container');
		// todo. 需要更好的方法找到上面那个td
		var tableCore = this.table.data('TableCore');
		this.dragStartTd = tableCore.getCellByPoint(ev.clientX, ev.clientY - 5);
		if (this.dragStartTd.length == 0) return;

		var guideTop = ev.pageY - this.table.offset().top;
		this.table.find(".table-row-resize-guide").css("top", guideTop + "px").css("left", "0").show();

		this.draggingWhat = 'RowGuide';
		$('body').bind("mousemove", $.proxy(this.draggingRowGuide, this));
		$('body').bind("selectstart", $.proxy(this.disableSelection, this));
		
		target.addClass("dragging");
		dragColumnStartY = ev.pageY;

		$(document).undelegate('td', 'mousemove', this.placeDraggerGuide);
	},

	draggingRowGuide: function(ev) {
		var draggerTop = ev.pageY - this.table.offset().top;
		var dragger = $(".dragging");
		dragger.css("top", draggerTop + "px").css("left", "0");

		var guideTop = ev.pageY - this.table.offset().top;
		this.table.find(".table-row-resize-guide").css("top", guideTop + "px").css("left", "0");
	},

	endDragRowGuide: function(ev) {
		$('body').unbind("mousemove", this.draggingRowGuide);
		$('body').unbind("selectstart", this.disableSelection);
		$(document).delegate('td', 'mousemove', this.placeDraggerGuide);
		
		// 调整高度
		var dragger = $(".dragging").removeClass('dragging');
		var changeHeight = ev.pageY - dragColumnStartY;

		var coord = this.dragStartTd.data('coord');
		var cell = {
			row: coord.row + coord.rowspan - 1,
			column: coord.column + coord.colspan - 1
		};

		var tableCore = this.table.data('TableCore');
		var cells = tableCore.getThinRowByCoord(cell);

		var newHeights = [];
		for (var i = 0; i < cells.length; i++) {
			var newHeight = $(cells[i]).outerHeight() + changeHeight;
			if (newHeight < 5) newHeight = 5;
			newHeights[i] = newHeight;
		}

		for (var i = 0; i < cells.length; i++) {
			$(cells[i]).css('height', newHeights[i]);
		}
	
		this.table.find(".table-row-resize-guide").hide();
	},

	dragColumnStartX: 0,
	startDragColumnGuide: function(ev) {
		var target = $(ev.target);
		this.table = target.closest('.table-container');
		// todo. 需要更好的方法找到左边那个td
		var tableCore = this.table.data('TableCore');
		this.dragStartTd = tableCore.getCellByPoint(ev.clientX - 5, ev.clientY);
		if (this.dragStartTd.length == 0) return;

		var guideLeft = ev.pageX - this.table.offset().left;
		this.table.find(".table-column-resize-guide").css("left", guideLeft + "px").css("top", "0").show();

		this.draggingWhat = 'ColumnGuide';
		$('body').bind("mousemove", $.proxy(this.draggingColumnGuide, this));
		$('body').bind("selectstart", $.proxy(this.disableSelection, this));

		target.addClass("dragging");
		dragColumnStartX = ev.pageX;

		$(document).undelegate('td', 'mousemove', this.placeDraggerGuide);
	},

	draggingColumnGuide: function(ev) {
		var draggerLeft = ev.pageX - this.table.offset().left;
		var dragger = $(".dragging");
		dragger.css("left", draggerLeft + "px").css("top", "0");
		
		var guideLeft = ev.pageX - this.table.offset().left;
		this.table.find(".table-column-resize-guide").css("left", guideLeft + "px").css("top", "0");
	},

	endDragColumnGuide: function(ev) {
		$('body').unbind("mousemove", this.draggingColumnGuide);
		$('body').unbind("selectstart", this.disableSelection);
		$(document).delegate('td', 'mousemove', this.placeDraggerGuide);
		
		// 调整宽度
		var dragger = $(".dragging").removeClass('dragging');
		var changeWidth = ev.pageX - dragColumnStartX;

		var coord = this.dragStartTd.data('coord');
		var cell = {
			row: coord.row + coord.rowspan - 1,
			column: coord.column + coord.colspan - 1
		};

		var tableCore = this.table.data('TableCore');
		var cells = tableCore.getThinColumnByCoord(cell);
		
		var newWidths = [];
		for (var i = 0; i < cells.length; i++) {
			var newWidth = $(cells[i]).width() + changeWidth;
			if (newWidth < 5) newWidth = 5;
			newWidths[i] = newWidth;	
		}

		for (var i = 0; i < cells.length; i++) {
			$(cells[i]).css('width', newWidths[i]);
		} 

		this.table.find(".table-column-resize-guide").hide();
	}
};